* Laboratorium Model Heckmana
clear
set mem 4m
set matsize 800
set more off

use "sciezka\hecklabt.dta"

describe

* obliczamy ilo "brakow"
count if lzarobki==.

* generujemy zmienna pomocnicza i rysujemy historgam
gen lz=lzarobki
recode lz .=0
histogram lz
histogram lz if tobit==1

* model regresji
reg lz plec wiek wiek2 wwiek wwiek2 rodzina
* test poprawnosci formy funkcyjnej
ovtest, rhs

* wiemy ze placa minimalna wynosila 687,50
di ln(687.50)

* model Tobitowy
tobit lz plec wiek wiek2 wwiek wwiek2 rodzina if tobit==1,ll(6.53) 

* efekty krancowe

* efekt kracowy
mfx compute

* efekt krancowy prawdopodobienstwa nieocenzurowania
mfx compute, predict(p(6.53,.))

* efekt krancowy warunkwoej wartosci oczekiwanej E(y | a<y<b)
mfx compute, predict(e(6.53,.))

* efekt krancowy wartosci oczekiwanej zmiennej ukrytej

mfx compute, predict (ys(6.53,.))

* wszystkie efekty - potrzeby pakiet dtobit

dtobit

* model regresji odwarzajacy Tobit
reg lz plec wiek wiek2 wwiek wwiek2 rodzina if lz>0 & tobit==1

* model Heckmana procedura dwustopniowa
heckman lzarobki plec wiek wiek2 wwiek wwiek2 rodzina,select(plec wiek wiek2 wwiek wwiek2 rodzina ld14 ldonp) twostep

* Dwustopniowa procedura Heckmana
* Model probitowy
probit select plec wiek wiek2 wwiek wwiek2 rodzina ld14 ldonp

* Lambdy
predict selecthat,xb
gen lambda = normden(selecthat) / norm(selecthat)

reg lzarobki plec wiek wiek2 wwiek wwiek2 rodzina lambda 

* model Heckmana MNW odtwarzajacy procedure dwustopniowa
heckman lzarobki plec wiek wiek2 wwiek wwiek2 rodzina,select(plec wiek wiek2 wwiek wwiek2 rodzina ld14 ldonp) iterate(0)

* model Heckmana MNW
heckman lzarobki plec wiek wiek2 wwiek wwiek2 rodzina,select(plec wiek wiek2 wwiek wwiek2 rodzina ld14 ldonp)

* model Heckmana MNW
heckman lzarobki plec wiek wiek2 wwiek wwiek2 rodzina,select(select=plec wiek wiek2 wwiek wwiek2 rodzina ld14 ldonp)

* efekty krancowe

* efekt krancowy E(y | y obserwowane)
mfx compute, predict(ycond)

* efekt krancowy Pr(y obserwowane)
mfx compute, predict(psel)

*efekt krancowy Pr(y oczewikane)
mfx compute, predict(yexpected)

* Model efektw oddziaywania
* Badamy zarobki osob z wyksztaceniem wyzszym

*Szacowany procedur dwukrokow
treatreg lzarobki plec wiek wiek2 ,treat(wyzsze=plec wiek wiek2 miastodu ) twostep

* Regresja
reg lzarobki plec wiek wiek2 rodzina if wyzsze==1 

* Szacowany MNW
treatreg lzarobki plec wiek wiek2 rodzina,treat(wyzsze=plec wiek wiek2 miastodu rodzina) 


*********************************************************************************************




